import i18n from '@/util/lang/lang'

let dom = null

async function asyncConstructor (Vue, comp) {
  if (!comp) {
    let component = await import('./index.vue')
    comp = Vue.extend(component.default)

    return comp
  }

  return comp
}

let Info = {}
Info.install = function (Vue, store) {
  let instance

  Vue.prototype.$showUserInfo = async () => {
    let Constructor = await asyncConstructor(Vue, dom)

    if (instance) {
      instance.visible = true
    } else {
      instance = new Constructor({
        el: document.createElement('div'),
        computed: {
          $store () { return store }
        },
        i18n,
        data () {
          return {
            visible: true
          }
        }
      })

      document.body.appendChild(instance.$el)
    }
  }
}

export default Info
